import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

public class UnChoix extends HttpServlet
{
	String chemin_annu;

	String sesIntitule[]={"Nom","Adresse","Numro de tlphone"};	
	
	// COULEURS POUR LE TABLEAUX
	String couleurTitre="#D3DCE3";
	String couleurLigne="lightgrey";  

	public void doGet(HttpServletRequest telleRequete,HttpServletResponse telleReponse)
		throws ServletException,IOException
	{
		telleReponse.setContentType("text/html");
		PrintWriter leFluxSortie=telleReponse.getWriter();
		
		int sonChoix=0;

		// Choix du fichier selon l'OS
		String os=System.getProperty("os.name");
		if(os.toLowerCase().indexOf("windows")!=-1) 
		{
			chemin_annu="c:/"+"/annuaire.txt";	
		}
		else
		{
			chemin_annu="/home/etude/annuaire.txt";	
		}		
		
		try
		{
			// On rcupre le paramtre choix	
			sonChoix=Integer.parseInt(telleRequete.getParameter("choix"));
		}
		// Cas o l'utilisateur aurait mis autre chose qu'un nombre en paramtre
		catch(NumberFormatException e)
		{
			html_header(leFluxSortie,"Erreur !",false);
			leFluxSortie.println("<EM><H2>Veuillez faire un choix</H2></EM>");
			leFluxSortie.println("<A HREF=\"../\">Retour  la page des choix</A>");
			html_footer(leFluxSortie);
			
			leFluxSortie.close();
			return;
			
		} // fin catch
		
		// LANCE LA METHODE CORRESPONDANTE A sonChoix
		switch(sonChoix)
		{
			case 1: affiche(telleRequete,leFluxSortie); 	break;
			case 2: ajouter(telleRequete,leFluxSortie);		break;
			case 3: suppression(telleRequete,leFluxSortie);	break;
			case 4: visualise(telleRequete,leFluxSortie); 	break;
			default : 
			
			html_header(leFluxSortie,"Erreur !",false);
			leFluxSortie.println("<EM><H2>Choix non valide</H2></EM>");
			leFluxSortie.println("<A HREF=\"../\">Retour  la page des choix</A>");
			html_footer(leFluxSortie);
					
		} // fin switch
		
		// Ferme le flux d'criture
		leFluxSortie.close();	
		
	} // fin doGet(...)
	
	/*
	 * METHODE D'AFFICHAGE DE L'ANNUAIRE
	 *
	 * @param telleRequete : Pour rcuprer les paramtres passs par l'user
	 * @param leFluxSortie : Pour crire vers le navigateur de l'user
	 *
	 */
	public void affiche(HttpServletRequest telleRequete,PrintWriter leFluxSortie)
	{
		try
		{
			String telLigne;
			int nbEnr=0;
			
			// ENTETES
			html_header(leFluxSortie,"Affichage de l'annuaire",true);
	
			// OUVERTURE DU FICHIER ANNUAIRE
			BufferedReader leFluxFic=new BufferedReader(new FileReader(chemin_annu));
				
			leFluxSortie.println("<TABLE CELLSPACING=\"1\" CELLPADDING=\"1\">");
			leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
			
			for(int i=0; i<sesIntitule.length;i++)
			{
				leFluxSortie.println("\t\t<TD width=\"200\"><B>"+sesIntitule[i]+"</B></TD>");
			}

			leFluxSortie.println("\t</TR>\n");		
			
			// ON LIT UNE PAR UNE LES LIGNES DU FICHIER
			while((telLigne=leFluxFic.readLine())!=null)
			{
				nbEnr++;
								
				// Alterne les couleurs du tableaux
				if(nbEnr%2!=0) 	couleurLigne="white";
				else			couleurLigne="lightgrey";

				leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
				
				StringTokenizer tk=new StringTokenizer(telLigne,":");
				
				// On parcourt chaque token de la chaine lue
				while(tk.hasMoreTokens())
					leFluxSortie.println("\t\t<TD>"+tk.nextToken()+"</TD>");
				
				leFluxSortie.println("\t</TR>\n");
				
			} // fin while			
			
			// AFFICHE LE NOMBRE D'ENREGISTREMENTS DE LA TABLE
			leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
			leFluxSortie.println("\t\t<TD COLSPAN=\"3\" ALIGN=\"center\">");
			leFluxSortie.print("\t\t\t<CENTER><B>");
			
			switch(nbEnr)
			{
				case 0:   leFluxSortie.print("Aucun enregistrement"); break;	
				case 1:   leFluxSortie.print("1 enregistrement"); break;
				default : leFluxSortie.print(nbEnr+" enregistrements");
				
			} // fin switch
			
			leFluxSortie.println("</B></CENTER>");

			leFluxSortie.println("\t\t</TD>");
			leFluxSortie.println("\t</TR>");		
			leFluxSortie.println("</TABLE>");
			
		}
		catch(FileNotFoundException e)
		{
			leFluxSortie.println("Fichier annuaire non disponible");
		}
		catch(IOException e)
		{
			leFluxSortie.println("Erreur I/O");
		}

		leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A>");		
		html_footer(leFluxSortie);
		
	} // fin affichage(...)


	/*
	 * METHODE D'AJOUT D'UN ABONNE
	 *
	 * @param telleRequete : Pour rcuprer les paramtres passs par l'user
	 * @param leFluxSortie : Pour crire vers le navigateur de l'user
	 *
	 */	
	public void ajouter(HttpServletRequest telleRequete,PrintWriter leFluxSortie)
	{
		// Si les 3 paramtres n'existent pas, nom, adresse, num sont  null
		String nom=telleRequete.getParameter("nom");
		String adresse=telleRequete.getParameter("adresse");
		String num=telleRequete.getParameter("num");
		
		// ----------------------
		// -- EFFECTUE L'AJOUT --
		// ----------------------		
		if(nom!=null && adresse!=null && num!=null)
		{
			try
			{ 
				nom=nom.trim();
				adresse=adresse.trim();
				num=num.trim();
				
				String chaine=nom+":"+adresse+":"+num;
				
				nom=nom.toLowerCase();
				adresse=adresse.toLowerCase();
				num=num.toLowerCase();
			
				if(nom.equals("") || adresse.equals("") || num.equals(""))
				{
					html_header(leFluxSortie,"Ajout d'un abonn",false);			
					leFluxSortie.println("Vous devez remplir tout les champs");
					leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");	
					leFluxSortie.println("<A HREF=\""+telleRequete.getRequestURI()+"?choix=2\">Retour  la page d'ajout d'un abonn</A>");	
					html_footer(leFluxSortie);
					return;
				}

				String interdit[]={"/","\\","<",">",":","\"","&",";","_"};
				
				for(int i=0; i<interdit.length;i++)
				{
					if(nom.indexOf(interdit[i])!=-1 || adresse.indexOf(interdit[i])!=-1 || num.indexOf(interdit[i])!=-1)
					{
						html_header(leFluxSortie,"Ajout d'un abonn",false);			
						leFluxSortie.println("Le caractre <B>"+interdit[i]+"</B> est interdit !!!");
						leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
						leFluxSortie.println("<A HREF=\""+telleRequete.getRequestURI()+"?choix=2\">Retour  la page d'ajout d'un abonn</A>");	
						html_footer(leFluxSortie);
						return;						
					}

				} // fin for
				
				if(!ligne_existe(chaine))
				{
					// OUVERTURE DU FICHIER ANNUAIRE
					BufferedWriter leFluxFic=new BufferedWriter(new FileWriter(chemin_annu,true));
					leFluxFic.write(chaine+"\n");
					leFluxFic.close();
	
					html_header(leFluxSortie,"Ajout d'un abonn",false);
					leFluxSortie.println("</HEAD>");
					leFluxSortie.println("<BODY>");				
					leFluxSortie.println("Nom : "+nom+"<BR>");
					leFluxSortie.println("Adresse : "+adresse+"<BR>");
					leFluxSortie.println("Numro : "+num+"<BR>");
					leFluxSortie.println("a t ajout<BR>");
					leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
					leFluxSortie.println("<A HREF=\""+telleRequete.getRequestURI()+"?choix=2\">Retour  la page d'ajout d'un abonn</A>");
				
				} // fin if
				else
				{
					html_header(leFluxSortie,"Ajout d'un abonn",false);			
					leFluxSortie.println("Cet abonn existe dj");
					leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
					leFluxSortie.println("<A HREF=\""+telleRequete.getRequestURI()+"?choix=2\">Retour  la page d'ajout d'un abonn</A>");
				
				} // fin else
				
			} // fin try
			catch(FileNotFoundException e)
			{
				html_header(leFluxSortie,"Ajout d'un abonn",false);
				leFluxSortie.println("Fichier annuaire non disponible");
				leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
			}
			catch(IOException e)
			{
				html_header(leFluxSortie,"Ajout d'un abonn",false);
				leFluxSortie.println("Erreur I/O");
				leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
			}
		
			html_footer(leFluxSortie);
			return;	
		
		} // fin if

		// -----------------------------------
		// -- AFFICHE LE FORMULAIRE D'AJOUT --
		// -----------------------------------
		
		// ENTETES
		html_header(leFluxSortie,"Ajout d'un abonn",true);
		
		leFluxSortie.println("<FORM METHOD=\"GET\" ACTION=\""+telleRequete.getRequestURI()+"\">");
		leFluxSortie.println("<INPUT TYPE=\"hidden\" NAME=\"choix\" VALUE=\"2\">");
		
		// AFFICHAGE DU TABLEAU			
		leFluxSortie.println("<TABLE CELLSPACING=\"1\" CELLPADDING=\"1\">");
		leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
		
		for(int i=0; i<sesIntitule.length;i++)
		{
			leFluxSortie.println("\t\t<TD><B>"+sesIntitule[i]+"</B></TD>");
		}

		leFluxSortie.println("\t</TR>\n");		
		
		leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
		
		// Le champ pour le nom
		leFluxSortie.print("\t\t<TD>");
		leFluxSortie.print("<INPUT TYPE=\"text\" NAME=\"nom\" SIZE=\"25\">");
		leFluxSortie.println("</TD>");
		
		// Le champ pour l'adresse
		leFluxSortie.print("\t\t<TD>");
		leFluxSortie.print("<INPUT TYPE=\"text\" NAME=\"adresse\" SIZE=\"25\">");
		leFluxSortie.println("</TD>");
		
		// Le champ pour le Numro
		leFluxSortie.print("\t\t<TD>");
		leFluxSortie.print("<INPUT TYPE=\"text\" NAME=\"num\" SIZE=\"25\">");
		leFluxSortie.println("</TD>");
			
		leFluxSortie.println("\t</TR>\n");

		// Ligne vide
		leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
		leFluxSortie.println("\t\t<TD COLSPAN=\"3\" ALIGN=\"center\">");
		leFluxSortie.println("\t\t</TD>");
		leFluxSortie.println("\t</TR>");
		
		leFluxSortie.println("\t<TR>\n\t\t<TD HEIGHT=\"30\"></TD>\n\t</TR>");
		
		// Les Boutons
		leFluxSortie.println("\t<TR>");
		leFluxSortie.println("\t\t<TD ALIGN=\"right\" COLSPAN=\"3\">");
		leFluxSortie.println("\t\t\t<INPUT TYPE=\"submit\" VALUE=\"Enregistrer\">&nbsp;");
		leFluxSortie.println("\t\t\t<INPUT TYPE=\"reset\" VALUE=\"Effacer\">");
		leFluxSortie.println("\t\t</TD>");
		leFluxSortie.println("\t</TR>");
				
		leFluxSortie.println("</TABLE>");
		leFluxSortie.println("</FORM>");
		leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
		leFluxSortie.println("<BR><A HREF=\""+telleRequete.getRequestURI()+"?choix=2\">Retour  la page d'ajout d'un abonn</A>");
		html_footer(leFluxSortie);

	} // fin modifier
	
	/*
	 * METHODE DE SUPPRESSION D'UN ABONNE
	 *
	 * @param telleRequete : Pour rcuprer les paramtres passs par l'user
	 * @param leFluxSortie : Pour crire vers le navigateur de l'user
	 *
	 */
	public void suppression(HttpServletRequest telleRequete,PrintWriter leFluxSortie)
	{
		// Si le paramtre ligne n'existe pas, ligneasupprimer est  null
		String ligneasupprimer=telleRequete.getParameter("ligne");
		String all=telleRequete.getParameter("all");

		// -----------------------------
		// -- EFFECTUE LA SUPPRESSION --
		// -----------------------------		
		if(ligneasupprimer!=null || all!=null)
		{
			try
			{
				if(all!=null && all.equals("yes"))
				{
					// OUVERTURE DU FICHIER ANNUAIRE
					BufferedWriter leFluxFicW=new BufferedWriter(new FileWriter(chemin_annu,false));
					leFluxFicW.write("");
					leFluxFicW.close();				
					
				}
				else
				{
			
					String chaine=new String();
					String lignelue;
			
					// OUVERTURE DU FICHIER ANNUAIRE EN LECTURE
					BufferedReader leFluxFic=new BufferedReader(new FileReader(chemin_annu));
					
					while((lignelue=leFluxFic.readLine())!=null)
					{	
						if(!lignelue.equals(ligneasupprimer))
							chaine+=lignelue+"\n";
					}
					leFluxFic.close();
					
					// OUVERTURE DU FICHIER ANNUAIRE
					BufferedWriter leFluxFicW=new BufferedWriter(new FileWriter(chemin_annu,false));
					if(!chaine.equals(""))
					{
						leFluxFicW.write(chaine.substring(0,chaine.length()-1)+"\n");
					}
					else
					{
						leFluxFicW.write("");	
					}
					leFluxFicW.close();
					
				} // fin else
			
			} // fin try	
			
			catch(FileNotFoundException e)
			{
				html_header(leFluxSortie,"Ajout d'un abonn",false);
				leFluxSortie.println("Fichier annuaire non disponible");
				leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
			}
			catch(IOException e)
			{
				html_header(leFluxSortie,"Ajout d'un abonn",false);
				leFluxSortie.println("Erreur I/O");
				leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
			}
			
		} // fin if
		
		// --------------------------------------------------------
		// -- AFFICHAGE DU TABLEAU AVEC LES LIENS DE SUPPRESSION --
		// --------------------------------------------------------
		try
		{
			String telLigne;
			int nbEnr=0;
			
			// ENTETES
			html_header(leFluxSortie,"Suppression d'un abonn",true);
	
			// OUVERTURE DU FICHIER ANNUAIRE
			BufferedReader leFluxFic=new BufferedReader(new FileReader(chemin_annu));
				
			leFluxSortie.println("<TABLE CELLSPACING=\"1\" CELLPADDING=\"1\">");
			leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
	
			for(int i=0; i<sesIntitule.length;i++)
			{
				leFluxSortie.println("\t\t<TD width=\"200\"><B>"+sesIntitule[i]+"</B></TD>");
			}
						
			leFluxSortie.println("\t\t<TD><B>Action ?</B></TD>");
			leFluxSortie.println("\t</TR>\n");		
			
			// ON LIT UNE PAR UNE LES LIGNES DU FICHIER
			while((telLigne=leFluxFic.readLine())!=null)
			{
				// Alterne les couleurs du tableaux
				if(nbEnr%2!=0)	couleurLigne="white";
				else			couleurLigne="lightgrey";

				leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
				
				StringTokenizer tk=new StringTokenizer(telLigne,":");
				String lignesuppr=new String();
				
				while(tk.hasMoreTokens())
				{
					String leToken=tk.nextToken();
					leFluxSortie.println("\t\t<TD>"+leToken+"</TD>");	
					lignesuppr+=leToken+":";

				} // fin while
				
				lignesuppr=lignesuppr.substring(0,lignesuppr.length()-1);
				
				leFluxSortie.println("\t\t<TD>");
				leFluxSortie.println("\t\t\t<A HREF=\""+telleRequete.getRequestURI()+"?choix=3&ligne="+lignesuppr+"\">Supprimer</A>");
				leFluxSortie.println("\t\t</TD>");	
				
				leFluxSortie.println("\t</TR>\n");
				nbEnr++;				
			
			} // fin while
			
			// AFFICHE LE NOMBRE D'ENREGISTREMENTS DE LA TABLE
			leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
			leFluxSortie.println("\t\t<TD COLSPAN=\"4\" ALIGN=\"center\">");
			leFluxSortie.print("\t\t\t<CENTER><B>");

			switch(nbEnr)
			{
				case 0:  leFluxSortie.print("Aucun enregistrement"); break;	
				case 1:  leFluxSortie.print("1 enregistrement"); break;
				default: leFluxSortie.print(nbEnr+" enregistrements");
			}
			
			leFluxSortie.println("</B></CENTER>");

			leFluxSortie.println("\t\t</TD>");
			leFluxSortie.println("\t</TR>");		
			leFluxSortie.println("</TABLE>");
			
			leFluxSortie.println("<A HREF=\""+telleRequete.getRequestURI()+"?choix=3&all=yes\">Supprimer tous les abonns</A>");
			
		} // fin try
		
		catch(FileNotFoundException e)
		{
			leFluxSortie.println("Fichier annuaire non disponible");
		}
		catch(IOException e)
		{
			leFluxSortie.println("Erreur I/O");
		}

		leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");		
		html_footer(leFluxSortie);
		
	} // fin suppression(...)
	
	/*
	 * METHODE DE RECHERCHE D'UN ABONNE
	 *
	 * @param telleRequete : Pour rcuprer les paramtres passs par l'user
	 * @param leFluxSortie : Pour crire vers le navigateur de l'user
	 *
	 */
	public void visualise(HttpServletRequest telleRequete,PrintWriter leFluxSortie)
	{
		
		html_header(leFluxSortie,"Recherche d'un abonn",true);
	
		// Si les paramtres n'existent pas, nom, adresse, num sont  null
		String nom=telleRequete.getParameter("nom");
		String adresse=telleRequete.getParameter("adresse");
		String num=telleRequete.getParameter("num");

		// ---------------------------
		// -- EFFECTUE LA RECHERCHE --
		// ---------------------------	
		if(nom!=null || adresse!=null || num!=null)
		{
			try
			{
				String telLigne;
				int nbEnr=0;
	
				// OUVERTURE DU FICHIER ANNUAIRE
				BufferedReader leFluxFic=new BufferedReader(new FileReader(chemin_annu));
					
				leFluxSortie.println("<TABLE CELLSPACING=\"1\" CELLPADDING=\"1\">");
				leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
		
				for(int i=0; i<sesIntitule.length;i++)
				{
					leFluxSortie.println("\t\t<TD width=\"200\"><B>"+sesIntitule[i]+"</B></TD>");
				}					

				leFluxSortie.println("\t</TR>\n");		
				
				// ON LIT UNE PAR UNE LES LIGNES DU FICHIER
				while((telLigne=leFluxFic.readLine())!=null)
				{
					// Alterne les couleurs du tableaux
					if(nbEnr%2!=0)	couleurLigne="white";
					else			couleurLigne="lightgrey";

					StringTokenizer tk=new StringTokenizer(telLigne,":");
					
					String token1=tk.nextToken();
					String token2=tk.nextToken();
					String token3=tk.nextToken();
					
					// Cas seulement adresse et numro en critre de recherche
					if(!nom.equals("") && adresse.equals("") && num.equals(""))
					{	
						if(token1.toLowerCase().indexOf(nom.toLowerCase())!=-1)
						{	leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
							leFluxSortie.println("\t\t<TD>"+token1+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token2+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token3+"</TD>");
							leFluxSortie.println("\t</TR>\n");
							
							nbEnr++;
						}
					}
					
					// Cas seulement le adresse en critre de recherche
					if(nom.equals("") && !adresse.equals("")  && num.equals(""))
					{	
						if(token2.toLowerCase().indexOf(adresse.toLowerCase())!=-1)
						{	leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
							leFluxSortie.println("\t\t<TD>"+token1+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token2+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token3+"</TD>");
							leFluxSortie.println("\t</TR>\n");
							
							nbEnr++;
						}
					}
					
					// Cas seulement le numero en critre de recherche
					if(nom.equals("") && adresse.equals("") && !num.equals("") )
					{	
						if(token3.toLowerCase().indexOf(num.toLowerCase())!=-1 && !num.equals(" "))
						{	leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
							leFluxSortie.println("\t\t<TD>"+token1+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token2+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token3+"</TD>");
							leFluxSortie.println("\t</TR>\n");
							
							nbEnr++;							
						}
					}
					
					// Cas nom et adresse en critre de recherche
					if(!nom.equals("") && !adresse.equals("") && num.equals(""))
					{							
						if(token2.toLowerCase().indexOf(adresse.toLowerCase())!=-1
							&& token1.toLowerCase().indexOf(nom.toLowerCase())!=-1)
						{	leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
							leFluxSortie.println("\t\t<TD>"+token1+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token2+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token3+"</TD>");
							leFluxSortie.println("\t</TR>\n");
							
							nbEnr++;
						}
					}
					
					// Cas nom et numero le numero en critre de recherche
					if(!nom.equals("") && adresse.equals("") && !num.equals("") )
					{
						if(token1.toLowerCase().indexOf(nom.toLowerCase())!=-1 
							&& token3.toLowerCase().indexOf(num.toLowerCase())!=-1 && !num.equals(" "))
						{	leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
							leFluxSortie.println("\t\t<TD>"+token1+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token2+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token3+"</TD>");
							leFluxSortie.println("\t</TR>\n");
							
							nbEnr++;
						}
					}
					
					// Cas adresse et numero en critre de recherche
					if(nom.equals("") && !adresse.equals("") && !num.equals(""))
					{
						if(token2.toLowerCase().indexOf(adresse.toLowerCase())!=-1 
							&& token3.toLowerCase().indexOf(num.toLowerCase())!=-1 && !num.equals(" "))
						{	leFluxSortie.println("\t<TR BGCOLOR=\""+couleurLigne+"\">");
							leFluxSortie.println("\t\t<TD>"+token1+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token2+"</TD>");
							leFluxSortie.println("\t\t<TD>"+token3+"</TD>");
							leFluxSortie.println("\t</TR>\n");
							
							nbEnr++;
						}
					}							
												
				} // fin while
				
				
				// AFFICHE LE NOMBRE D'ENREGISTREMENTS DE LA TABLE
				leFluxSortie.println("\t<TR BGCOLOR=\""+couleurTitre+"\">");
				leFluxSortie.println("\t\t<TD COLSPAN=\"3\" ALIGN=\"center\">");
				leFluxSortie.print("\t\t\t<CENTER><B>");
				
				switch(nbEnr)
				{
					case 0:   leFluxSortie.println("Aucun abonn trouv"); break;	
					case 1:   leFluxSortie.println("1 abonn trouv"); break;
					default : leFluxSortie.println(nbEnr+" abonns trouvs");
				}
				
				leFluxSortie.println("</B></CENTER>");
				leFluxSortie.println("\t\t</TD>");
				leFluxSortie.println("\t</TR>");		
				leFluxSortie.println("</TABLE>");
				
			} // fin try
			
			catch(FileNotFoundException e)
			{
				leFluxSortie.println("Fichier annuaire non disponible<BR>");
			}
			catch(IOException e)
			{
				leFluxSortie.println("Erreur I/O<BR>");
			}
			
			leFluxSortie.println("<A HREF=\""+telleRequete.getRequestURI()+"?choix=4\">Autre recherche</A>");
			leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");
			html_footer(leFluxSortie);
			return;
				
		} // fin if
	
		// ----------------------------------------
		// -- AFFICHE LE FORMULAIRE DE RECHERCHE --
		// ----------------------------------------
		leFluxSortie.println("<FORM METHOD=\"GET\" ACTION=\""+telleRequete.getRequestURI()+"\">");
		leFluxSortie.println("<INPUT TYPE=\"hidden\" NAME=\"choix\" VALUE=\"4\">");
		leFluxSortie.println("<TABLE CELLSPACING=\"1\" CELLPADDING=\"1\">");
		leFluxSortie.println("<TR BGCOLOR=\""+couleurTitre+"\">");

		for(int i=0; i<sesIntitule.length;i++)
		{
			leFluxSortie.println("\t\t<TD><B>"+sesIntitule[i]+"</B></TD>");
		}	

		leFluxSortie.println("</TR>");
		
		leFluxSortie.println("<TR>");
		leFluxSortie.println("<TD><INPUT TYPE=\"text\" NAME=\"nom\" SIZE=\"25\"></TD>");
		leFluxSortie.println("<TD><INPUT TYPE=\"text\" NAME=\"adresse\" SIZE=\"25\"></TD>");
		leFluxSortie.println("<TD><INPUT TYPE=\"text\" NAME=\"num\" SIZE=\"25\"></TD>");
		leFluxSortie.println("</TR>");
		
		leFluxSortie.println("<TR BGCOLOR=\""+couleurTitre+"\">");
		leFluxSortie.println("<TD COLSPAN=\"3\" ALIGN=\"center\">");
		leFluxSortie.println("<INPUT TYPE=\"submit\" VALUE=\"Rechercher\">");
		leFluxSortie.println("</TD>");		
		leFluxSortie.println("</TR>");
		leFluxSortie.println("</TABLE>");
		leFluxSortie.println("</FORM>");
		
		leFluxSortie.println("<BR><BR><A HREF=\"../\">Retour  la page des choix</A><BR>");		
		html_footer(leFluxSortie);
		
	} // fin visualise(...)
	
	
	/*
	 * METHODE QUI IMPRIME L'ENTETE HTML
	 *
	 * @param leFluxSortie	: le flux vers le navigateur
	 * @param title		   	: le titre  afficher
	 * @param grosTitre		: affiche le titre en gros dans la page
	 */	
	public void html_header(PrintWriter leFluxSortie,String title,boolean grosTitre)
	{
		leFluxSortie.println("<HTML>");
		leFluxSortie.println("<HEAD>");
		leFluxSortie.println("<TITLE>"+title+"</TITLE>");
		leFluxSortie.println("</HEAD>");
		leFluxSortie.println("<BODY BGCOLOR=\"white\">");
		if(grosTitre)
			leFluxSortie.println("<EM><H2>"+title+"</H2></EM>");		
			
	} // fin html_header(...)
	
	/*
	 * METHODE QUI IMPRIME LE PIED DE PAGE HTML
	 *
	 * @param leFluxSortie	: le flux vers le navigateur
	 */	
	public void html_footer(PrintWriter leFluxSortie)
	{
		leFluxSortie.println("</BODY></HTML>");
		
	} // fin html_footer(...)	
	

	/*
	 * METHODE QUI TESTE SI UN ABONNE EXISTE DEJA DANS L'ANNUAIRE
	 *
	 * @param  telleLigneSearched : ligne  tester
	 * @return true : si l'abonn existe dj
	 *		   false: si l'abonn n'existe pas
	 */		
	public boolean ligne_existe(String telleLigneSearched)
		throws FileNotFoundException,IOException
	{
		String telLigne=null;
		
		BufferedReader leFluxFic=new BufferedReader(new FileReader(chemin_annu));	
		while((telLigne=leFluxFic.readLine())!=null)
		{
			if(telLigne.equalsIgnoreCase(telleLigneSearched))
				return true;
			
		}
		leFluxFic.close();
		return false;
			
	} // fin ligne_existe
					  
}